# Copyrights 2007-2013 by [Mark Overmeer].
#  For other contributors see ChangeLog.
# See the manual pages for details on the licensing terms.
# Pod stripped from pm file by OODoc 2.01.
use warnings;
use strict;

package MojoX::Log::Report;
use vars '$VERSION';
$VERSION = '0.999';

use Mojo::Base 'Mojo::Log';

use Log::Report 'log-report', import => 'report';


sub new(@) {
    my $class = shift;
    my $self  = $class->SUPER::new(@_);

    # issue with Mojo <= 4.52, where the base-class registers a function, not
    # a method to handle the message.
    $self->unsubscribe('message');  # clean all listeners
    $self->on(message => sub { shift->_message(@_) });
    return $self;
}

my %level2reason = qw/
 debug  TRACE
 info   INFO
 warn   WARNING
 error  ERROR
 fatal  ALERT
/;

sub _message($$@)
{   my ($self, $level) = (shift, shift);
 
    report +{is_fatal => 0}    # do not die on errors
      , $level2reason{$level}, join('', @_);
}

1;
